
<!-- Geometry for Vertex detector sensors -->

<!-- R detector is 182 tubs with guardring strip -->
  <logvol name="lvVeloRDetector&ModNum;" 
          material="Silicon" 
          sensdet="GiGaSensDetTracker/&SensDet;">
    <union name="detectorRUnion">
        <tubs name="detectorRTubs" 
	      sizeZ         = "SiThick"
              outerRadius   = "OuterRadius" 
              innerRadius   = "InnerRadius"
              startPhiAngle = "-1*(RDetPhiSpan+0.5*degree)/2" 
	      deltaPhiAngle = "RDetPhiSpan+0.5*degree"/>
	<box name="rDetGuardRing1"
             sizeX="GuardRing"
             sizeY="OuterRadius-InnerRadius"
             sizeZ="SiThick"/>
             <posXYZ x="-1*(GuardRing/(2*cos(1*pi*rad/180))+(sin(1*pi*rad/180)*(OuterRadius+InnerRadius)/2))"
                     y="(OuterRadius+InnerRadius)/2"/>
             <rotXYZ rotZ="(RDetPhiSpan-180*degree)/2"/>
	<box name="rDetGuardRing2"
             sizeX="GuardRing"
             sizeY="OuterRadius-InnerRadius"
             sizeZ="SiThick"/>
             <posXYZ x="-1*(GuardRing/(2*cos(1*pi*rad/180))+(sin(1*pi*rad/180)*(OuterRadius+InnerRadius)/2))"
                     y="-1*(OuterRadius+InnerRadius)/2"/>
             <rotXYZ rotZ="(180*degree-RDetPhiSpan)/2"/>
    </union>
  </logvol>

<!-- Phi detector has messy dog-leg geometry -->
  <logvol name="lvVeloPhiDetector&ModNum;" 
          material="Silicon" 
          sensdet="GiGaSensDetTracker/&SensDet;">
    <union name="detectorPhiUnion">
        <tubs name="detectorPhiTubs" 
	      sizeZ         = "SiThick"
	      outerRadius   = "OuterRadius" 
	      innerRadius   = "InnerRadius"
	      startPhiAngle = "-1*PhiDetPhiSpan/2" 
	      deltaPhiAngle = "PhiDetPhiSpan"/>
        <trap name="detectorPhiTrap1"
              sizeX2="PhiTrap1X2"
              sizeX1="PhiTrap1X1"
              sizeY1="(OuterRadius-Inner2OuterRadius)"
              sizeY2="(OuterRadius-Inner2OuterRadius)"
              sizeX4="PhiTrap1X2"
              sizeX3="PhiTrap1X1"
              sizeZ="SiThick"
              alp1="-1*atan((PhiTrap1X2-PhiTrap1X1)/2/(OuterRadius-Inner2OuterRadius))"
              alp2="-1*atan((PhiTrap1X2-PhiTrap1X1)/2/(OuterRadius-Inner2OuterRadius))"/>
        <posXYZ x="-1*(PhiTrap1X2+PhiTrap1X1)/4"
                y="-1*(OuterRadius+Inner2OuterRadius)/2"/>
        <trap name="detectorPhiTrap2"
              sizeX2="PhiTrap2X2"
              sizeX1="PhiTrap1X2"
              sizeY1="(Inner2OuterRadius-InnerRadius)"
              sizeY2="(Inner2OuterRadius-InnerRadius)"
              sizeX4="PhiTrap2X2"
              sizeX3="PhiTrap1X2"
              sizeZ="SiThick"
              alp1="atan((PhiTrap1X2-PhiTrap2X2)/2/(Inner2OuterRadius-InnerRadius))"
              alp2="atan((PhiTrap1X2-PhiTrap2X2)/2/(Inner2OuterRadius-InnerRadius))"/>
        <posXYZ x="-1*(PhiTrap1X2+PhiTrap2X2)/4"
                y="-1*(Inner2OuterRadius+InnerRadius)/2"/>
        <trap name="detectorPhiTrap3"
              sizeX2="PhiTrap3X2"
              sizeX1="PhiTrap3X1"
              sizeY1="(OuterRadius-InnerRadius)"
              sizeY2="(OuterRadius-InnerRadius)"
              sizeX4="PhiTrap3X2"
              sizeX3="PhiTrap3X1"
              sizeZ="SiThick"
              alp1="-1*atan((PhiTrap3X2-PhiTrap3X1)/2/(OuterRadius-InnerRadius))"
              alp2="-1*atan((PhiTrap3X2-PhiTrap3X1)/2/(OuterRadius-InnerRadius))"/>
        <posXYZ x="-1*mm*(PhiTrap3X2+PhiTrap3X1)/4"
                y="(OuterRadius+InnerRadius)/2"/>
    </union>
  </logvol>


  <!-- Upstream sensor pair by default (downstream needs rotation about X axis) -->

  <logvol name="lvVeloPair&ModNum;" material="Vacuum">
    <union name="PairUnion">
        <tubs name="PairTubs"
	      sizeZ         = "RPhiDist+SiThick+Epsilon"
              outerRadius   = "OuterRadius+Epsilon" 
              innerRadius   = "InnerRadius-Epsilon"
              startPhiAngle = "-90.25*degree" 
	      deltaPhiAngle = "180.5*degree"/>
	<box name="PairBox1"
             sizeX="3.5*mm"
             sizeY="OuterRadius-InnerRadius+2*Epsilon"
             sizeZ="RPhiDist+SiThick+Epsilon"/>
	     <posXYZ x="-3*mm/2"
	             y="(OuterRadius+InnerRadius)/2"/>
	<box name="PairBox2"
             sizeX="3.5*mm"
             sizeY="OuterRadius-InnerRadius+2*Epsilon"
             sizeZ="RPhiDist+SiThick+Epsilon"/>
	     <posXYZ x="-3*mm/2"
	             y="-1*(OuterRadius+InnerRadius)/2"/>
    </union>

    <!-- Left half of station -->
    <!-- apply +(-)0.5*RightLeftDist when placing L (R) in Velo -->
    <!-- R -->
    <physvol name="pvDetR" 
             logvol="/dd/Geometry/BeforeMagnetRegion/Velo/Sensors/lvVeloRDetector&ModNum;">
      <posXYZ z="-.5*RPhiDist"/>
      <rotXYZ rotX="0*degree" rotY="0*degree" rotZ="0*degree"/>
    </physvol>
    <!-- Phi -->
    <physvol name="pvDetPhi" 
            logvol="/dd/Geometry/BeforeMagnetRegion/Velo/Sensors/lvVeloPhiDetector&ModNum;">
      <posXYZ z=".5*RPhiDist"/>
      <rotXYZ rotX="0*degree" rotY="0*degree" rotZ="0*degree"/>
    </physvol>

  </logvol>

  <logvol name="lvVeloModule&ModNum;">

    <physvol name="pvRPhiPair&ModNum;" 
             logvol="/dd/Geometry/BeforeMagnetRegion/Velo/RPhiPairs/lvVeloPair&ModNum;">
    </physvol>
    <physvol name="vSupportUL" 
             logvol="/dd/Geometry/BeforeMagnetRegion/Velo/Supports/lvVeloSupport">
      <posXYZ x="SupportX1/2+SupportX2/2"/>
      <rotXYZ rotX="180*degree" rotY="0*degree" rotZ="0*degree"/>
    </physvol>

  </logvol>
